module bellek_yonetimi_3;

import std.stdio;
import std.meta;
import std.traits;

struct BoşYapı {
}

struct Yapı {
    char c;
    double d;
}

class BoşSınıf {
}

class Sınıf {
    char karakter;
}

void main() {
    alias Türler = AliasSeq!(char, short, int, long,
                             double, real,
                             string, int[int], int*,
                             BoşYapı, Yapı, BoşSınıf, Sınıf);

    writeln(" Uzunluk  Hizalama  Tür\n",
            "========================");

    foreach (Tür; Türler) {
        static if (is (Tür == class)) {
            size_t uzunluk = __traits(classInstanceSize, Tür);
            size_t hizalama = classInstanceAlignment!Tür;

        } else {
            size_t uzunluk = Tür.sizeof;
            size_t hizalama = Tür.alignof;
        }

        writefln("%6s%9s     %s",
                 uzunluk, hizalama, Tür.stringof);
    }
}
