module clear_2;

import std.stdio;
class YaşamıGözlenen {
    int[] dizi;       // ← her nesnenin kendisine aittir

    static int sayaç; // ← bütün nesneler tarafından
                      //   paylaşılır

    this() {
        /* Her nesne bellekte çok yer tutsun diye bu diziyi
         * çok sayıda int'lik hale getiriyoruz. Nesnelerin
         * böyle büyük olmalarının sonucunda çöp
         * toplayıcının bellek açmak için onları daha sık
         * sonlandıracağını umuyoruz. */
        dizi.length = 30_000;

        /* Bir nesne daha kurulmuş olduğundan nesne sayacını
         * bir arttırıyoruz. */
        ++sayaç;
    }

    ~this() {
        /* Bir nesne daha sonlandırılmış olduğundan nesne
         * sayacını bir azaltıyoruz. */
        --sayaç;
    }
}
void main() {
    foreach (i; 0 .. 20) {
        auto değişken = new YaşamıGözlenen;
        write(YaşamıGözlenen.sayaç, ' ');
        destroy(değişken);
    }

    writeln();
}
