module es_zamanli_shared_6;

import std.stdio;
import std.concurrency;
import core.thread;

enum adet = 1000;

void arttırıcı(shared(int) * değer) {
    foreach (i; 0 .. adet) {
        synchronized {  // ← bu kilit aşağıdakinden farklıdır
            *değer = *değer + 1;
        }
    }
}

void azaltıcı(shared(int) * değer) {
    foreach (i; 0 .. adet) {
        synchronized {  // ← bu kilit yukarıdakinden farklıdır
            *değer = *değer - 1;
        }
    }
}

void main() {
    shared(int) ortak = 0;

    foreach (i; 0 .. 100) {
        spawn(&arttırıcı, &ortak);
        spawn(&azaltıcı, &ortak);
    }

    thread_joinAll();
    writeln("son değeri: ", ortak);
}
