module es_zamanli_shared_7;

import std.stdio;
import std.concurrency;
import core.thread;

enum adet = 1000;

class Kilit {
}

void arttırıcı(shared(int) * değer, shared(Kilit) kilit) {
    foreach (i; 0 .. adet) {
        synchronized (kilit) {
            *değer = *değer + 1;
        }
    }
}

void azaltıcı(shared(int) * değer, shared(Kilit) kilit) {
    foreach (i; 0 .. adet) {
        synchronized (kilit) {
            *değer = *değer - 1;
        }
    }
}

void main() {
    shared(Kilit) kilit = new shared(Kilit)();
    shared(int) ortak = 0;

    foreach (i; 0 .. 100) {
        spawn(&arttırıcı, &ortak, kilit);
        spawn(&azaltıcı, &ortak, kilit);
    }

    thread_joinAll();
    writeln("son değeri: ", ortak);
}
