module fiberler_4;

import core.thread;

/* Elemanları üretir ve 'ref' parametresine atar. */
void fibonacciSerisi(ref int baştaki) {                 // (1)
    baştaki = 0;    // Not: 'baştaki' parametrenin kendisidir
    int sonraki = 1;

    while (true) {
        Fiber.yield();                                  // (2)
        /* Bir sonraki call() çağrısı tam bu noktadan
         * devam eder. */                               // (3)

        const ikiSonraki = baştaki + sonraki;
        baştaki = sonraki;
        sonraki = ikiSonraki;
    }
}

void main() {
    int baştaki;                                        // (1)
                         // (4)
    Fiber fiber = new Fiber(() => fibonacciSerisi(baştaki));

    foreach (_; 0 .. 10) {
        fiber.call();                                   // (5)

        import std.stdio;
        writef("%s ", baştaki);
    }
}
