module ic_tanimlar_3;

import std.stdio;
import std.array;

auto baştanSondan(T)(T[] dilim) {
    bool baştan_mı = true;

    struct BaştanSondanAralığı {
        bool empty() const {
            return dilim.empty;
        }

        T front() const {
            return baştan_mı ? dilim.front : dilim.back;
        }

        void popFront() {
            if (baştan_mı) {
                dilim.popFront();
                baştan_mı = false;

            } else {
                dilim.popBack();
                baştan_mı = true;
            }
        }
    }

    return BaştanSondanAralığı();
}

void main() {
    auto a = baştanSondan([ 1, 2, 3, 4, 5 ]);
    writeln(a);
}
