module kosullu_derleme_3;

import std.stdio;

struct VeriYapısı(T) {
    static if (is (T == float)) {
        alias SonuçTürü = double;

    } else static if (is (T == double)) {
        alias SonuçTürü = real;

    } else {
        static assert(false, T.stringof ~ " desteklenmiyor");
    }

    SonuçTürü işlem() {
        writefln("%s için sonuç türü olarak %s kullanıyorum.",
                 T.stringof, SonuçTürü.stringof);
        SonuçTürü sonuç;
        // ...
        return sonuç;
    }
}

void main() {
    auto f = VeriYapısı!float();
    f.işlem();

    auto d = VeriYapısı!double();
    d.işlem();
}
