module kosut_islemler_11;

import std.stdio;
import std.algorithm;
import std.conv;

double çeyreği(double değer) {
    return değer / 4;
}

string onKatı(double değer) {
    return to!string(değer * 10);
}

void main() {
    auto sayılar = [10, 42, 100];
    auto sonuçlar = map!(çeyreği, onKatı)(sayılar);

    writefln("  Çeyreği  On Katı");

    foreach (çeyrekSonucu, onKatSonucu; sonuçlar) {
        writefln("%8.2f%8s", çeyrekSonucu, onKatSonucu);
    }
}
