module main_cozum_1;

import std.stdio;
import std.conv;

int main(string[] parametreler) {
    if (parametreler.length != 4) {
        stderr.writeln(
            "HATA! Doğru kullanım: \n    ", parametreler[0],
            " bir_sayı işlem başka_sayı");
        return 1;
    }

    immutable birinci = to!double(parametreler[1]);
    string işlem = parametreler[2];
    immutable ikinci = to!double(parametreler[3]);

    switch (işlem) {

    case "+":
        writeln(birinci + ikinci);
        break;

    case "-":
        writeln(birinci - ikinci);
        break;

    case "x":
        writeln(birinci * ikinci);
        break;

    case "/":
        writeln(birinci / ikinci);
        break;

    default:
        throw new Exception("Geçersiz işlem: " ~ işlem);
    }

    return 0;
}
