module sablonlar_ayrintili_2;

import std.stdio;
class Toplayıcı {
    string içerik;

    void ekle(T)(auto ref const T değer) {
        import std.conv;
        içerik ~= değer.to!string;
    }
}

class KümeParantezliToplayıcı : Toplayıcı {
    /* Bu şablon üst sınıftakinin yeni tanımı değildir; üst
     * sınıftaki 'ekle' ismini gizlemektedir. */
    void ekle(T)(auto ref const T değer) {
        import std.string;
        super.ekle(format("{%s}", değer));
    }
}

void toplayıcıyıDoldur(Toplayıcı toplayıcı) {
    /* Aşağıdaki işlev çağrıları sanal değildir. Buradaki
     * 'toplayıcı' parametresinin türü 'Toplayıcı' olduğundan
     * her iki çağrı da Toplayıcı.ekle şablonuna
     * devredilirler. */

    toplayıcı.ekle(42);
    toplayıcı.ekle("merhaba");
}

void main() {
    auto toplayıcı = new KümeParantezliToplayıcı();
    toplayıcıyıDoldur(toplayıcı);

    import std.stdio;
    writeln(toplayıcı.içerik);
}
