module tureme_cozum_1;

import std.stdio;

class DemirYoluAracı {
    void ilerle(size_t kilometre) {
        writefln("Araç %s kilometre ilerliyor:", kilometre);

        foreach (i; 0 .. kilometre / 100) {
            writefln("  %s", sesÇıkart());
        }
    }

    abstract string sesÇıkart();
}

class Vagon : DemirYoluAracı {
    override string sesÇıkart() const {
        return "takıtak tukutak";
    }

    // ...
}

class YolcuVagonu : Vagon {
    // ...
}

class YükVagonu : Vagon {
    // ...
}

class Lokomotif : DemirYoluAracı {
    override string sesÇıkart() {
        return "çuf çuf";
    }
}

void main() {
    auto vagon1 = new YolcuVagonu;
    vagon1.ilerle(100);

    auto vagon2 = new YükVagonu;
    vagon2.ilerle(200);

    auto lokomotif = new Lokomotif;
    lokomotif.ilerle(300);
}
