module ufcs_1;

class Araba {
    enum ekonomi = 12.5;           // litre başına km (ortalama)
    private double kalanBenzin;    // litre

    this(double kalanBenzin) {
        this.kalanBenzin = kalanBenzin;
    }

    double benzin() const {
        return kalanBenzin;
    }

    // ...
}
bool gidebilir_mi(Araba araba, double mesafe) {
    return (araba.benzin() * araba.ekonomi) >= mesafe;
}
void main() {
    auto araba = new Araba(5);

    auto kalanBenzin = araba.benzin(); // Üye işlev söz dizimi

    if (gidebilir_mi(araba, 100)) {    // Normal işlev söz dizimi
        // ...
    }
}
