module araliklar_8;

import std.stdio;
struct FibonacciSerisi {
// ...

    FibonacciSerisi save() const {
        return this;
    }
    int baştaki = 0;
    int sonraki = 1;

    enum empty = false;  // ← sonsuz aralık

    int front() const {
        return baştaki;
    }

    void popFront() {
        const ikiSonraki = baştaki + sonraki;
        baştaki = sonraki;
        sonraki = ikiSonraki;
    }
}
import std.range;

// ...

void bilgiVer(T)(const dchar[] başlık, const ref T aralık) {
    writefln("%40s: %s", başlık, aralık.take(5));
}

void main() {
    auto aralık = FibonacciSerisi();
    bilgiVer("Başlangıçtaki aralık", aralık);

    aralık.popFrontN(2);
    bilgiVer("İki eleman çıkartıldıktan sonra", aralık);

    auto kopyası = aralık.save;
    bilgiVer("Kopyası", kopyası);

    aralık.popFrontN(3);
    bilgiVer("Üç eleman daha çıkartıldıktan sonra", aralık);
    bilgiVer("Kopyası", kopyası);
}
