module araliklar_9;

import std.array;
import std.stdio;

struct TersSırada {
    int[] aralık;

    this(int[] aralık) {
        this.aralık = aralık;
    }

    bool empty() const {
        return aralık.empty;
    }

    int front() const {
        return aralık.back;  // ← ters
    }

    int back() const {
        return aralık.front; // ← ters
    }

    void popFront() {
        aralık.popBack();    // ← ters
    }

    void popBack() {
        aralık.popFront();   // ← ters
    }
}

void main() {
    writeln(TersSırada([ 1, 2, 3]));
}
