module clear_3;

import std.stdio;
import std.array;
import std.random;
import std.conv;

string girintiDizgisi(int girintiAdımı) {
    return replicate(" ", girintiAdımı * 2);
}

class XmlElemanı {
    string isim;
    string girinti;

    this(string isim, int düzey) {
        this.isim = isim;
        this.girinti = girintiDizgisi(düzey);

        writeln(girinti, '<', isim, '>');
    }

    ~this() {
        writeln(girinti, "</", isim, '>');
    }
}

void main() {
    const dersler = new XmlElemanı("dersler", 0);

    foreach (dersNumarası; 0 .. 2) {
        const ders = new XmlElemanı(
            "ders" ~ to!string(dersNumarası), 1);

        foreach (i; 0 .. 3) {
            const not = new XmlElemanı("not", 2);
            const rasgeleNot = uniform(50, 101);

            writeln(girintiDizgisi(3), rasgeleNot);
        }
    }
}
