module diziler_cozum_2;

import std.stdio;
import std.algorithm;

void main() {
    // Kaç tane sayı geleceğini baştan bilmediğimiz için
    // dinamik diziler kullanıyoruz
    int[] tekler;
    int[] çiftler;

    writeln("Lütfen tamsayılar girin (sonlandırmak için -1)");

    while (true) {

        // Sayıyı okuyoruz
        int sayı;
        readf(" %s", &sayı);

        // Sayı özellikle -1 olduğunda döngüden çıkıyoruz
        if (sayı == -1) {
            break;
        }

        // Tek veya çift olması durumuna göre farklı dizinin
        // sonuna yerleştiriyoruz; ikiye bölümünden kalan 0
        // ise çifttir, değilse tektir
        if ((sayı % 2) == 0) {
            çiftler ~= sayı;

        } else {
            tekler ~= sayı;
        }
    }

    // Önce tekleri ve çiftleri ayrı ayrı sıralıyoruz
    sort(tekler);
    sort(çiftler);

    // Ondan sonra birleştiriyoruz
    int[] sonuç;
    sonuç = tekler ~ çiftler;

    writeln("Önce tekler, sonra çiftler; sıralı olarak:");

    // Daha önce gördüğümüz gibi bir döngü kurarak dizinin
    // bütün elemanlarını çıkışa yazdırıyoruz
    int i;
    while (i < sonuç.length) {
        write(sonuç[i], " ");
        ++i;
    }

    writeln();
}
