module es_zamanli_7;

import std.stdio;
import std.concurrency;

struct Sonlan {
}

void işçiİşlevi() {
    bool devam_mı = true;

    while (devam_mı) {
        receive(
            (int mesaj) {
                writeln("int mesaj: ", mesaj);
            },

            (string mesaj) {
                writeln("string mesaj: ", mesaj);
            },

            (Sonlan mesaj) {
                writeln("çıkıyorum");
                devam_mı = false;
            });
    }
}

void main() {
    auto işçi = spawn(&işçiİşlevi);

    işçi.send(10);
    işçi.send(42);
    işçi.send("merhaba");
    işçi.send(Sonlan());
}
