module es_zamanli_shared_5;

import std.stdio;
import std.concurrency;
import core.thread;

void değişTokuşçu(shared(int) * birinci, shared(int) * ikinci) {
    foreach (i; 0 .. 10_000) {
        int geçici = *ikinci;
        *ikinci = *birinci;
        *birinci = geçici;
    }
}

void main() {
    shared(int) i = 1;
    shared(int) j = 2;

    writefln("önce : %s ve %s", i, j);

    foreach (adet; 0 .. 10) {
        spawn(&değişTokuşçu, &i, &j);
    }

    // Bütün işlemlerin bitmesini bekliyoruz
    thread_joinAll();

    writefln("sonra: %s ve %s", i, j);
}
