module foreach_opapply_1;

import std.stdio;

enum Renk { mavi, yeşil, kırmızı }

struct Nokta {
    int x;
    int y;
}

struct Poligon {
    Renk renk;
    Nokta[] noktalar;

    int opApply(int delegate(ref const(Nokta)) işlemler) const {
        int sonuç = 0;

        foreach (nokta; noktalar) {
            sonuç = işlemler(nokta);

            if (sonuç) {
                break;
            }
        }

        return sonuç;
    }
}

void main() {
    auto poligon = Poligon(Renk.mavi,
                           [ Nokta(0, 0), Nokta(1, 1) ] );

    foreach (nokta; poligon) {
        writeln(nokta);
    }
}
