module gostergeler_10;

import std.stdio;
import std.stdio;

void baytlarınıGöster(T)(ref T değişken) {
    const ubyte * baş = cast(ubyte*)&değişken;    // (1)

    writefln("tür    : %s", T.stringof);
    writefln("değer  : %s", değişken);
    writefln("adres  : %s", baş);                 // (2)
    writef  ("baytlar: ");

    writefln("%(%02x %)", baş[0 .. T.sizeof]);    // (3)

    writeln();
}
struct Yapı {
    int birinci;
    int ikinci;
}

class Sınıf {
    int i;
    int j;

    this(int i, int j) {
        this.i = i;
        this.j = j;
    }
}

void main() {
    int tamsayı = 0x11223344;
    baytlarınıGöster(tamsayı);

    double kesirli = double.nan;
    baytlarınıGöster(kesirli);

    string dizgi = "merhaba dünya";
    baytlarınıGöster(dizgi);

    int[3] dizi = [ 1, 2, 3 ];
    baytlarınıGöster(dizi);

    auto yapıNesnesi = Yapı(0xaa, 0xbb);
    baytlarınıGöster(yapıNesnesi);

    auto sınıfDeğişkeni = new Sınıf(1, 2);
    baytlarınıGöster(sınıfDeğişkeni);
}
