module hatalar_10;

import std.stdio;
import std.exception;
import std.string;

void dosyayıKullan(string dosyaİsmi) {
    auto dosya = File(dosyaİsmi, "r");
    // ...
}

string dizgiOku(string soru) {
    write(soru, ": ");
    string dizgi = strip(readln());

    return dizgi;
}

void main() {
    bool dosyaKullanılabildi = false;

    while (!dosyaKullanılabildi) {
        try {
            dosyayıKullan(
                dizgiOku("Dosyanın ismini giriniz"));

            /* Eğer bu noktaya gelebildiysek, dosyayıKullan
             * işlevi başarıyla sonlanmış demektir. Yani,
             * verilen dosya ismi geçerlidir.
             *
             * Bu yüzden bu noktada bu değişkenin değerini
             * 'true' yaparak while'ın sonlanmasını
             * sağlıyoruz. */
            dosyaKullanılabildi = true;
            writeln("Dosya başarıyla kullanıldı");

        } catch (std.exception.ErrnoException açmaHatası) {
            stderr.writeln("Bu dosya açılamadı");
        }
    }
}
