module hatalar_9;

import std.stdio;

void foo() {
    try {
        throw new Exception("foo'daki asıl hata");

    } finally {
        throw new Exception("foo'daki finally hatası");
    }
}

void bar() {
    try {
        foo();

    } finally {
        throw new Exception("bar'daki finally hatası");
    }
}

void main() {
    try {
        bar();

    } catch (Exception yakalananHata) {

        for (Throwable hata = yakalananHata;
             hata;    // Anlamı: null olmadığı sürece
             hata = hata.next) {

            writefln("mesaj: %s", hata.msg);
            writefln("dosya: %s", hata.file);
            writefln("satır: %s", hata.line);
            writeln();
        }
    }
}
