module interface_3;

interface Oyun {
    final void oynat() {
        string isim = oyunİsmi();
        writefln("%s oyunu başlıyor", isim);

        oyuncularıTanı();
        hazırlan();
        başlat();
        sonlandır();

        writefln("%s oyunu bitti", isim);
    }

    string oyunİsmi();
    void oyuncularıTanı();
    void hazırlan();
    void başlat();
    void sonlandır();
}
import std.stdio;
import std.string;
import std.random;
import std.conv;

class ZarToplamıOyunu : Oyun {
    string oyuncu;
    size_t adet;
    size_t toplam;

    string oyunİsmi() {
        return "Zar Toplamı";
    }

    void oyuncularıTanı() {
        write("İsminiz nedir? ");
        oyuncu = strip(readln());
    }

    void hazırlan() {
        write("Kaç kere zar atılsın? ");
        readf(" %s", &adet);
        toplam = 0;
    }

    void başlat() {
        foreach (i; 0 .. adet) {
            immutable zar = uniform(1, 7);
            writefln("%s: %s", i, zar);
            toplam += zar;
        }
    }

    void sonlandır() {
        writefln("Oyuncu: %s, Zar toplamı: %s, Ortalama: %s",
                 oyuncu, toplam, to!double(toplam) / adet);
    }
}

void kullan(Oyun oyun) {
    oyun.oynat();
}

void main() {
    kullan(new ZarToplamıOyunu());
}
