module islec_yukleme_4;

import std.random;
import std.stdio;
import std.string;
import std.algorithm;

struct GününSaati {
    int saat;
    int dakika;

    int opCmp(GününSaati sağdaki) const {
        return (saat == sağdaki.saat
                ? dakika - sağdaki.dakika
                : saat - sağdaki.saat);
    }

    string toString() const {
        return format("%02s:%02s", saat, dakika);
    }
}

void main() {
    GününSaati[] zamanlar;

    foreach (i; 0 .. 10) {
        zamanlar ~= GününSaati(uniform(0, 24), uniform(0, 60));
    }

    sort(zamanlar);

    writeln(zamanlar);
}
