module katmalar_2;

import std.stdio;
mixin template KöşeDizisiOlanağı(T, size_t adet) {
    T[adet] köşeler;

    void köşeDeğiştir(size_t indeks, T köşe) {
        köşeler[indeks] = köşe;
    }

    void köşeleriGöster() {
        writeln("Bütün köşelerim:");

        foreach (i, köşe; köşeler) {
            writef("%s:%s ", i, köşe);
        }

        writeln();
    }
}
struct Nokta {
    int x;
    int y;
}

void main() {
    mixin KöşeDizisiOlanağı!(Nokta, 5);

    köşeDeğiştir(3, Nokta(3, 3));
    köşeleriGöster();
}
