module parametre_serbestligi_1;

import std.stdio;
import std.algorithm;

// ...

void tabloYazdır(string başlık,
                 string[string] tablo,
                 string indeksAyracı,
                 string elemanAyracı) {
    writeln("-- ", başlık, " --");

    auto indeksler = sort(tablo.keys);

    // İlk elemandan önce eleman ayracı olmamalı
    if (indeksler.length != 0) {
        auto indeks = indeksler[0];
        write(indeks, indeksAyracı, tablo[indeks]);
        indeksler = indeksler[1..$];    // İlk elemanı çıkart
    }

    // Diğer elemanlardan önce eleman ayracı yazdırılmalı
    foreach (indeks; indeksler) {
        write(elemanAyracı);
        write(indeks, indeksAyracı, tablo[indeks]);
    }

    writeln();
}
void main() {
    string[string] sözlük = [
        "mavi":"blue", "kırmızı":"red", "gri":"gray" ];

    tabloYazdır("Renk Sözlüğü", sözlük, ":", ", ");
}
