module parametre_serbestligi_5;

int[] sonraKullanmakÜzereSayılar;

void foo(int[] sayılar...) {
    /* Bu, belirsiz sayıda parametre alan foo() işlevi
     * olduğundan, kendilerini gösteren dilim saklamadan önce
     * elemanların kopyalarını almak gerekir. */
    sonraKullanmakÜzereSayılar = sayılar.dup;
}

void foo(int[] sayılar) {
    /* Bu, normal dilim alan foo() işlevi olduğundan, dilimi
     * olduğu gibi saklayabiliriz. */
    sonraKullanmakÜzereSayılar = sayılar;
}

struct S {
    string[] sonraKullanmakÜzereİsimler;

    void foo(string[] isimler...) {
        /* Bu, belirsiz sayıda parametre alan S.foo() işlevi
         * olduğundan, kendilerini gösteren dilim saklamadan
         * önce elemanların kopyalarını almak gerekir. */
        sonraKullanmakÜzereİsimler = isimler.dup;
    }

    void foo(string[] isimler) {
        /* Bu, normal dilim alan S.foo() işlevi olduğundan,
         * dilimi olduğu gibi saklayabiliriz. */
        sonraKullanmakÜzereİsimler = isimler;
    }
}

void bar() {
    /* Bu çağrı, belirsiz sayıda parametre alan işleve
     * yönlendirilir. */
    foo(1, 10, 100);

    /* Bu çağrı, normal dilim alan işleve yönlendirilir. */
    foo([ 2, 20, 200 ]);

    auto s = S();

    /* Bu çağrı, belirsiz sayıda parametre alan işleve
     * yönlendirilir. */
    s.foo("merhaba", "dünya");

    /* Bu çağrı, normal dilim alan işleve yönlendirilir. */
    s.foo([ "selam", "ay" ]);

    // ...
}

void main() {
    bar();
}
