module parametre_serbestligi_cozum_1;

import std.stdio;

enum İşlem { toplama, çıkarma, çarpma, bölme }

struct Hesap {
    İşlem işlem;
    double birinci;
    double ikinci;
}

double[] hesapla(Hesap[] hesaplar...) {
    double[] sonuçlar;

    foreach (hesap; hesaplar) {
        final switch (hesap.işlem) {

        case İşlem.toplama:
            sonuçlar ~= hesap.birinci + hesap.ikinci;
            break;

        case İşlem.çıkarma:
            sonuçlar ~= hesap.birinci - hesap.ikinci;
            break;

        case İşlem.çarpma:
            sonuçlar ~= hesap.birinci * hesap.ikinci;
            break;

        case İşlem.bölme:
            sonuçlar ~= hesap.birinci / hesap.ikinci;
            break;
        }
    }

    return sonuçlar;
}

void main() {
    writeln(hesapla(Hesap(İşlem.toplama, 1.1, 2.2),
                    Hesap(İşlem.çıkarma, 3.3, 4.4),
                    Hesap(İşlem.çarpma, 5.5, 6.6),
                    Hesap(İşlem.bölme, 7.7, 8.8)));
}
