module sablonlar_ayrintili_3;

template elemanAdedi(AsılTür, ParçaTürü) {
    enum elemanAdedi = (AsılTür.sizeof + (ParçaTürü.sizeof - 1))
                       / ParçaTürü.sizeof;
}
union ParçalıDeğer(AsılTür, ParçaTürü) {
    AsılTür değer;
    ParçaTürü[elemanAdedi!(AsılTür, ParçaTürü)] parçalar;
}
import std.stdio;

void main() {
    auto adres = ParçalıDeğer!(uint, ubyte)(0xc0a80102);

    foreach (eleman; adres.parçalar) {
        write(eleman, ' ');
    }
}
