module ufcs_3;

// Bütün elemanların 'bölen' ile bölünmüşlerini döndürür
int[] bölümleri(int[] dilim, int bölen) {
    int[] sonuç;
    sonuç.reserve(dilim.length);

    foreach (değer; dilim) {
        sonuç ~= değer / bölen;
    }

    return sonuç;
}

// Bütün elemanların 'çarpan' ile çarpılmışlarını döndürür
int[] çarpımları(int[] dilim, int çarpan) {
    int[] sonuç;
    sonuç.reserve(dilim.length);

    foreach (değer; dilim) {
        sonuç ~= değer * çarpan;
    }

    return sonuç;
}

// Elemanların çift olanlarını döndürür
int[] çiftleri(int[] dilim) {
    int[] sonuç;
    sonuç.reserve(dilim.length);

    foreach (değer; dilim) {
        if (!(değer % 2)) {
            sonuç ~= değer;
        }
    }

    return sonuç;
}
import std.stdio;

// ...

void main() {
    auto sayılar = [ 1, 2, 3, 4, 5 ];
    writeln(çiftleri(bölümleri(çarpımları(sayılar, 10), 3)));
}
