module yapilar_5;

import std.stdio;

struct Nokta {
    // Her nesnenin kendi tanıtıcı numarası
    size_t numara;

    int satır;
    int sütun;

    // Bundan sonra oluşturulacak olan nesnenin numarası
    static size_t sonrakiNumara;
}

Nokta NoktaOluştur(int satır, int sütun) {
    size_t numara = Nokta.sonrakiNumara;
    ++Nokta.sonrakiNumara;

    return Nokta(numara, satır, sütun);
}

void main() {
    auto üstteki = NoktaOluştur(7, 0);
    auto ortadaki = NoktaOluştur(8, 0);
    auto alttaki =  NoktaOluştur(9, 0);

    writeln(üstteki.numara);
    writeln(ortadaki.numara);
    writeln(alttaki.numara);
}
